diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/class-phpmailer.php ./wordpress-3.4/wp-includes/class-phpmailer.php
*** ./wordpress-3.3.2/wp-includes/class-phpmailer.php	2011-06-01 15:42:47.000000000 -0500
--- ./wordpress-3.4/wp-includes/class-phpmailer.php	2012-05-03 11:41:59.000000000 -0500
***************
*** 2,16 ****
  /*~ class.phpmailer.php
  .---------------------------------------------------------------------------.
  |  Software: PHPMailer - PHP email class                                    |
! |   Version: 5.1                                                            |
! |   Contact: via sourceforge.net support pages (also www.worxware.com)      |
! |      Info: http://phpmailer.sourceforge.net                               |
! |   Support: http://sourceforge.net/projects/phpmailer/                     |
  | ------------------------------------------------------------------------- |
! |     Admin: Andy Prevost (project admininistrator)                         |
  |   Authors: Andy Prevost (codeworxtech) codeworxtech@users.sourceforge.net |
  |          : Marcus Bointon (coolbru) coolbru@users.sourceforge.net         |
  |   Founder: Brent R. Matzelle (original founder)                           |
  | Copyright (c) 2004-2009, Andy Prevost. All Rights Reserved.               |
  | Copyright (c) 2001-2003, Brent R. Matzelle                                |
  | ------------------------------------------------------------------------- |
--- 2,16 ----
  /*~ class.phpmailer.php
  .---------------------------------------------------------------------------.
  |  Software: PHPMailer - PHP email class                                    |
! |   Version: 5.2.1                                                          |
! |      Site: https://code.google.com/a/apache-extras.org/p/phpmailer/       |
  | ------------------------------------------------------------------------- |
! |     Admin: Jim Jagielski (project admininistrator)                        |
  |   Authors: Andy Prevost (codeworxtech) codeworxtech@users.sourceforge.net |
  |          : Marcus Bointon (coolbru) coolbru@users.sourceforge.net         |
+ |          : Jim Jagielski (jimjag) jimjag@gmail.com                        |
  |   Founder: Brent R. Matzelle (original founder)                           |
+ | Copyright (c) 2010-2012, Jim Jagielski. All Rights Reserved.              |
  | Copyright (c) 2004-2009, Andy Prevost. All Rights Reserved.               |
  | Copyright (c) 2001-2003, Brent R. Matzelle                                |
  | ------------------------------------------------------------------------- |
***************
*** 19,29 ****
  | This program is distributed in the hope that it will be useful - WITHOUT  |
  | ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     |
  | FITNESS FOR A PARTICULAR PURPOSE.                                         |
- | ------------------------------------------------------------------------- |
- | We offer a number of paid services (www.worxware.com):                    |
- | - Web Hosting on highly optimized fast and secure servers                 |
- | - Technology Consulting                                                   |
- | - Oursourcing (highly qualified programmers and graphic designers)        |
  '---------------------------------------------------------------------------'
  */
  
--- 19,24 ----
***************
*** 33,40 ****
   * @package PHPMailer
   * @author Andy Prevost
   * @author Marcus Bointon
   * @copyright 2004 - 2009 Andy Prevost
!  * @version $Id: class.phpmailer.php 447 2009-05-25 01:36:38Z codeworxtech $
   * @license http://www.gnu.org/copyleft/lesser.html GNU Lesser General Public License
   */
  
--- 28,37 ----
   * @package PHPMailer
   * @author Andy Prevost
   * @author Marcus Bointon
+  * @author Jim Jagielski
+  * @copyright 2010 - 2012 Jim Jagielski
   * @copyright 2004 - 2009 Andy Prevost
!  * @version $Id: class.phpmailer.php 450 2010-06-23 16:46:33Z coolbru $
   * @license http://www.gnu.org/copyleft/lesser.html GNU Lesser General Public License
   */
  
***************
*** 119,124 ****
--- 116,142 ----
    public $AltBody           = '';
  
    /**
+    * Stores the complete compiled MIME message body.
+    * @var string
+    * @access protected
+    */
+   protected $MIMEBody       = '';
+ 
+   /**
+    * Stores the complete compiled MIME message headers.
+    * @var string
+    * @access protected
+    */
+   protected $MIMEHeader     = '';
+ 
+   /**
+    * Stores the complete sent MIME message (Body and Headers)
+    * @var string
+    * @access protected
+   */
+   protected $SentMIMEMessage     = '';
+ 
+   /**
     * Sets word wrapping on the body of the message to a given number of
     * characters.
     * @var int
***************
*** 271,276 ****
--- 289,300 ----
  
    /**
     * Used with DKIM DNS Resource Record
+    * @var string
+    */
+   public $DKIM_passphrase   = '';
+ 
+   /**
+    * Used with DKIM DNS Resource Record
     * optional, in format of email address 'you@yourdomain.com'
     * @var string
     */
***************
*** 300,327 ****
     * Sets the PHPMailer Version number
     * @var string
     */
!   public $Version         = '5.1';
  
    /////////////////////////////////////////////////
    // PROPERTIES, PRIVATE AND PROTECTED
    /////////////////////////////////////////////////
  
!   private   $smtp           = NULL;
!   private   $to             = array();
!   private   $cc             = array();
!   private   $bcc            = array();
!   private   $ReplyTo        = array();
!   private   $all_recipients = array();
!   private   $attachment     = array();
!   private   $CustomHeader   = array();
!   private   $message_type   = '';
!   private   $boundary       = array();
!   protected $language       = array();
!   private   $error_count    = 0;
!   private   $sign_cert_file = "";
!   private   $sign_key_file  = "";
!   private   $sign_key_pass  = "";
!   private   $exceptions     = false;
  
    /////////////////////////////////////////////////
    // CONSTANTS
--- 324,357 ----
     * Sets the PHPMailer Version number
     * @var string
     */
!   public $Version         = '5.2.1';
! 
!   /**
!    * What to use in the X-Mailer header
!    * @var string
!    */
!   public $XMailer         = '';
  
    /////////////////////////////////////////////////
    // PROPERTIES, PRIVATE AND PROTECTED
    /////////////////////////////////////////////////
  
!   protected   $smtp           = NULL;
!   protected   $to             = array();
!   protected   $cc             = array();
!   protected   $bcc            = array();
!   protected   $ReplyTo        = array();
!   protected   $all_recipients = array();
!   protected   $attachment     = array();
!   protected   $CustomHeader   = array();
!   protected   $message_type   = '';
!   protected   $boundary       = array();
!   protected   $language       = array();
!   protected   $error_count    = 0;
!   protected   $sign_cert_file = '';
!   protected   $sign_key_file  = '';
!   protected   $sign_key_pass  = '';
!   protected   $exceptions     = false;
  
    /////////////////////////////////////////////////
    // CONSTANTS
***************
*** 437,443 ****
     * @return boolean
     */
    public function AddReplyTo($address, $name = '') {
!     return $this->AddAnAddress('ReplyTo', $address, $name);
    }
  
    /**
--- 467,473 ----
     * @return boolean
     */
    public function AddReplyTo($address, $name = '') {
!     return $this->AddAnAddress('Reply-To', $address, $name);
    }
  
    /**
***************
*** 447,457 ****
     * @param string $address The email address to send to
     * @param string $name
     * @return boolean true on success, false if address already used or invalid in some way
!    * @access private
     */
!   private function AddAnAddress($kind, $address, $name = '') {
!     if (!preg_match('/^(to|cc|bcc|ReplyTo)$/', $kind)) {
!       echo 'Invalid recipient array: ' . $kind;
        return false;
      }
      $address = trim($address);
--- 477,493 ----
     * @param string $address The email address to send to
     * @param string $name
     * @return boolean true on success, false if address already used or invalid in some way
!    * @access protected
     */
!   protected function AddAnAddress($kind, $address, $name = '') {
!     if (!preg_match('/^(to|cc|bcc|Reply-To)$/', $kind)) {
!       $this->SetError($this->Lang('Invalid recipient array').': '.$kind);
!       if ($this->exceptions) {
!         throw new phpmailerException('Invalid recipient array: ' . $kind);
!       }
! 	  if ($this->SMTPDebug) {
!         echo $this->Lang('Invalid recipient array').': '.$kind;
!       }
        return false;
      }
      $address = trim($address);
***************
*** 461,470 ****
        if ($this->exceptions) {
          throw new phpmailerException($this->Lang('invalid_address').': '.$address);
        }
!       echo $this->Lang('invalid_address').': '.$address;
        return false;
      }
!     if ($kind != 'ReplyTo') {
        if (!isset($this->all_recipients[strtolower($address)])) {
          array_push($this->$kind, array($address, $name));
          $this->all_recipients[strtolower($address)] = true;
--- 497,508 ----
        if ($this->exceptions) {
          throw new phpmailerException($this->Lang('invalid_address').': '.$address);
        }
! 	  if ($this->SMTPDebug) {
!         echo $this->Lang('invalid_address').': '.$address;
!       }
        return false;
      }
!     if ($kind != 'Reply-To') {
        if (!isset($this->all_recipients[strtolower($address)])) {
          array_push($this->$kind, array($address, $name));
          $this->all_recipients[strtolower($address)] = true;
***************
*** 485,491 ****
   * @param string $name
   * @return boolean
   */
!   public function SetFrom($address, $name = '',$auto=1) {
      $address = trim($address);
      $name = trim(preg_replace('/[\r\n]+/', '', $name)); //Strip breaks and trim
      if (!self::ValidateAddress($address)) {
--- 523,529 ----
   * @param string $name
   * @return boolean
   */
!   public function SetFrom($address, $name = '', $auto = 1) {
      $address = trim($address);
      $name = trim(preg_replace('/[\r\n]+/', '', $name)); //Strip breaks and trim
      if (!self::ValidateAddress($address)) {
***************
*** 493,506 ****
        if ($this->exceptions) {
          throw new phpmailerException($this->Lang('invalid_address').': '.$address);
        }
!       echo $this->Lang('invalid_address').': '.$address;
        return false;
      }
      $this->From = $address;
      $this->FromName = $name;
      if ($auto) {
        if (empty($this->ReplyTo)) {
!         $this->AddAnAddress('ReplyTo', $address, $name);
        }
        if (empty($this->Sender)) {
          $this->Sender = $address;
--- 531,546 ----
        if ($this->exceptions) {
          throw new phpmailerException($this->Lang('invalid_address').': '.$address);
        }
! 	  if ($this->SMTPDebug) {
!         echo $this->Lang('invalid_address').': '.$address;
!       }
        return false;
      }
      $this->From = $address;
      $this->FromName = $name;
      if ($auto) {
        if (empty($this->ReplyTo)) {
!         $this->AddAnAddress('Reply-To', $address, $name);
        }
        if (empty($this->Sender)) {
          $this->Sender = $address;
***************
*** 544,549 ****
--- 584,604 ----
     */
    public function Send() {
      try {
+       if(!$this->PreSend()) return false;
+       return $this->PostSend();
+     } catch (phpmailerException $e) {
+ 	  $this->SentMIMEMessage = '';
+       $this->SetError($e->getMessage());
+       if ($this->exceptions) {
+         throw $e;
+       }
+       return false;
+     }
+   }
+ 
+   protected function PreSend() {
+     try {
+ 	  $mailHeader = "";
        if ((count($this->to) + count($this->cc) + count($this->bcc)) < 1) {
          throw new phpmailerException($this->Lang('provide_address'), self::STOP_CRITICAL);
        }
***************
*** 555,581 ****
  
        $this->error_count = 0; // reset errors
        $this->SetMessageType();
!       $header = $this->CreateHeader();
!       $body = $this->CreateBody();
! 
        if (empty($this->Body)) {
          throw new phpmailerException($this->Lang('empty_message'), self::STOP_CRITICAL);
        }
  
        // digitally sign with DKIM if enabled
        if ($this->DKIM_domain && $this->DKIM_private) {
!         $header_dkim = $this->DKIM_Add($header,$this->Subject,$body);
!         $header = str_replace("\r\n","\n",$header_dkim) . $header;
        }
  
        // Choose the mailer and send through it
        switch($this->Mailer) {
          case 'sendmail':
!           return $this->SendmailSend($header, $body);
          case 'smtp':
!           return $this->SmtpSend($header, $body);
          default:
!           return $this->MailSend($header, $body);
        }
  
      } catch (phpmailerException $e) {
--- 610,667 ----
  
        $this->error_count = 0; // reset errors
        $this->SetMessageType();
!       //Refuse to send an empty message
        if (empty($this->Body)) {
          throw new phpmailerException($this->Lang('empty_message'), self::STOP_CRITICAL);
        }
  
+       $this->MIMEHeader = $this->CreateHeader();
+       $this->MIMEBody = $this->CreateBody();
+ 
+       // To capture the complete message when using mail(), create
+ 	  // an extra header list which CreateHeader() doesn't fold in
+       if ($this->Mailer == 'mail') {
+         if (count($this->to) > 0) {
+           $mailHeader .= $this->AddrAppend("To", $this->to);
+         } else {
+           $mailHeader .= $this->HeaderLine("To", "undisclosed-recipients:;");
+         }
+         $mailHeader .= $this->HeaderLine('Subject', $this->EncodeHeader($this->SecureHeader(trim($this->Subject))));
+         // if(count($this->cc) > 0) {
+             // $mailHeader .= $this->AddrAppend("Cc", $this->cc);
+         // }
+       }
+ 
        // digitally sign with DKIM if enabled
        if ($this->DKIM_domain && $this->DKIM_private) {
!         $header_dkim = $this->DKIM_Add($this->MIMEHeader, $this->EncodeHeader($this->SecureHeader($this->Subject)), $this->MIMEBody);
!         $this->MIMEHeader = str_replace("\r\n", "\n", $header_dkim) . $this->MIMEHeader;
!       }
! 
!       $this->SentMIMEMessage = sprintf("%s%s\r\n\r\n%s",$this->MIMEHeader,$mailHeader,$this->MIMEBody);
!       return true;
! 
!     } catch (phpmailerException $e) {
!       $this->SetError($e->getMessage());
!       if ($this->exceptions) {
!         throw $e;
        }
+       return false;
+     }
+   }
  
+   protected function PostSend() {
+     try {
        // Choose the mailer and send through it
        switch($this->Mailer) {
          case 'sendmail':
!           return $this->SendmailSend($this->MIMEHeader, $this->MIMEBody);
          case 'smtp':
!           return $this->SmtpSend($this->MIMEHeader, $this->MIMEBody);
!         case 'mail':
!           return $this->MailSend($this->MIMEHeader, $this->MIMEBody);
          default:
!           return $this->MailSend($this->MIMEHeader, $this->MIMEBody);
        }
  
      } catch (phpmailerException $e) {
***************
*** 583,589 ****
        if ($this->exceptions) {
          throw $e;
        }
!       echo $e->getMessage()."\n";
        return false;
      }
    }
--- 669,677 ----
        if ($this->exceptions) {
          throw $e;
        }
! 	  if ($this->SMTPDebug) {
!         echo $e->getMessage()."\n";
!       }
        return false;
      }
    }
***************
*** 612,618 ****
          $result = pclose($mail);
          // implement call back function if it exists
          $isSent = ($result == 0) ? 1 : 0;
!         $this->doCallback($isSent,$val,$this->cc,$this->bcc,$this->Subject,$body);
          if($result != 0) {
            throw new phpmailerException($this->Lang('execute') . $this->Sendmail, self::STOP_CRITICAL);
          }
--- 700,706 ----
          $result = pclose($mail);
          // implement call back function if it exists
          $isSent = ($result == 0) ? 1 : 0;
!         $this->doCallback($isSent, $val, $this->cc, $this->bcc, $this->Subject, $body);
          if($result != 0) {
            throw new phpmailerException($this->Lang('execute') . $this->Sendmail, self::STOP_CRITICAL);
          }
***************
*** 626,632 ****
        $result = pclose($mail);
        // implement call back function if it exists
        $isSent = ($result == 0) ? 1 : 0;
!       $this->doCallback($isSent,$this->to,$this->cc,$this->bcc,$this->Subject,$body);
        if($result != 0) {
          throw new phpmailerException($this->Lang('execute') . $this->Sendmail, self::STOP_CRITICAL);
        }
--- 714,720 ----
        $result = pclose($mail);
        // implement call back function if it exists
        $isSent = ($result == 0) ? 1 : 0;
!       $this->doCallback($isSent, $this->to, $this->cc, $this->bcc, $this->Subject, $body);
        if($result != 0) {
          throw new phpmailerException($this->Lang('execute') . $this->Sendmail, self::STOP_CRITICAL);
        }
***************
*** 648,655 ****
      }
      $to = implode(', ', $toArr);
  
!     $params = sprintf("-oi -f %s", $this->Sender);
!     if ($this->Sender != '' && strlen(ini_get('safe_mode'))< 1) {
        $old_from = ini_get('sendmail_from');
        ini_set('sendmail_from', $this->Sender);
        if ($this->SingleTo === true && count($toArr) > 1) {
--- 736,747 ----
      }
      $to = implode(', ', $toArr);
  
!     if (empty($this->Sender)) {
!       $params = "-oi ";
!     } else {
!       $params = sprintf("-oi -f %s", $this->Sender);
!     }
!     if ($this->Sender != '' and !ini_get('safe_mode')) {
        $old_from = ini_get('sendmail_from');
        ini_set('sendmail_from', $this->Sender);
        if ($this->SingleTo === true && count($toArr) > 1) {
***************
*** 657,669 ****
            $rt = @mail($val, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
            // implement call back function if it exists
            $isSent = ($rt == 1) ? 1 : 0;
!           $this->doCallback($isSent,$val,$this->cc,$this->bcc,$this->Subject,$body);
          }
        } else {
          $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
          // implement call back function if it exists
          $isSent = ($rt == 1) ? 1 : 0;
!         $this->doCallback($isSent,$to,$this->cc,$this->bcc,$this->Subject,$body);
        }
      } else {
        if ($this->SingleTo === true && count($toArr) > 1) {
--- 749,761 ----
            $rt = @mail($val, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
            // implement call back function if it exists
            $isSent = ($rt == 1) ? 1 : 0;
!           $this->doCallback($isSent, $val, $this->cc, $this->bcc, $this->Subject, $body);
          }
        } else {
          $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
          // implement call back function if it exists
          $isSent = ($rt == 1) ? 1 : 0;
!         $this->doCallback($isSent, $to, $this->cc, $this->bcc, $this->Subject, $body);
        }
      } else {
        if ($this->SingleTo === true && count($toArr) > 1) {
***************
*** 671,683 ****
            $rt = @mail($val, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
            // implement call back function if it exists
            $isSent = ($rt == 1) ? 1 : 0;
!           $this->doCallback($isSent,$val,$this->cc,$this->bcc,$this->Subject,$body);
          }
        } else {
!         $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header);
          // implement call back function if it exists
          $isSent = ($rt == 1) ? 1 : 0;
!         $this->doCallback($isSent,$to,$this->cc,$this->bcc,$this->Subject,$body);
        }
      }
      if (isset($old_from)) {
--- 763,775 ----
            $rt = @mail($val, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
            // implement call back function if it exists
            $isSent = ($rt == 1) ? 1 : 0;
!           $this->doCallback($isSent, $val, $this->cc, $this->bcc, $this->Subject, $body);
          }
        } else {
!         $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
          // implement call back function if it exists
          $isSent = ($rt == 1) ? 1 : 0;
!         $this->doCallback($isSent, $to, $this->cc, $this->bcc, $this->Subject, $body);
        }
      }
      if (isset($old_from)) {
***************
*** 716,726 ****
          $bad_rcpt[] = $to[0];
          // implement call back function if it exists
          $isSent = 0;
!         $this->doCallback($isSent,$to[0],'','',$this->Subject,$body);
        } else {
          // implement call back function if it exists
          $isSent = 1;
!         $this->doCallback($isSent,$to[0],'','',$this->Subject,$body);
        }
      }
      foreach($this->cc as $cc) {
--- 808,818 ----
          $bad_rcpt[] = $to[0];
          // implement call back function if it exists
          $isSent = 0;
!         $this->doCallback($isSent, $to[0], '', '', $this->Subject, $body);
        } else {
          // implement call back function if it exists
          $isSent = 1;
!         $this->doCallback($isSent, $to[0], '', '', $this->Subject, $body);
        }
      }
      foreach($this->cc as $cc) {
***************
*** 728,738 ****
          $bad_rcpt[] = $cc[0];
          // implement call back function if it exists
          $isSent = 0;
!         $this->doCallback($isSent,'',$cc[0],'',$this->Subject,$body);
        } else {
          // implement call back function if it exists
          $isSent = 1;
!         $this->doCallback($isSent,'',$cc[0],'',$this->Subject,$body);
        }
      }
      foreach($this->bcc as $bcc) {
--- 820,830 ----
          $bad_rcpt[] = $cc[0];
          // implement call back function if it exists
          $isSent = 0;
!         $this->doCallback($isSent, '', $cc[0], '', $this->Subject, $body);
        } else {
          // implement call back function if it exists
          $isSent = 1;
!         $this->doCallback($isSent, '', $cc[0], '', $this->Subject, $body);
        }
      }
      foreach($this->bcc as $bcc) {
***************
*** 740,750 ****
          $bad_rcpt[] = $bcc[0];
          // implement call back function if it exists
          $isSent = 0;
!         $this->doCallback($isSent,'','',$bcc[0],$this->Subject,$body);
        } else {
          // implement call back function if it exists
          $isSent = 1;
!         $this->doCallback($isSent,'','',$bcc[0],$this->Subject,$body);
        }
      }
  
--- 832,842 ----
          $bad_rcpt[] = $bcc[0];
          // implement call back function if it exists
          $isSent = 0;
!         $this->doCallback($isSent, '', '', $bcc[0], $this->Subject, $body);
        } else {
          // implement call back function if it exists
          $isSent = 1;
!         $this->doCallback($isSent, '', '', $bcc[0], $this->Subject, $body);
        }
      }
  
***************
*** 822,828 ****
        }
      } catch (phpmailerException $e) {
        $this->smtp->Reset();
!       throw $e;
      }
      return true;
    }
--- 914,922 ----
        }
      } catch (phpmailerException $e) {
        $this->smtp->Reset();
! 	  if ($this->exceptions) {
!         throw $e;
!       }
      }
      return true;
    }
***************
*** 942,948 ****
  
      $line = explode($this->LE, $message);
      $message = '';
!     for ($i=0 ;$i < count($line); $i++) {
        $line_part = explode(' ', $line[$i]);
        $buf = '';
        for ($e = 0; $e<count($line_part); $e++) {
--- 1036,1042 ----
  
      $line = explode($this->LE, $message);
      $message = '';
!     for ($i = 0 ;$i < count($line); $i++) {
        $line_part = explode(' ', $line[$i]);
        $buf = '';
        for ($e = 0; $e<count($line_part); $e++) {
***************
*** 1056,1062 ****
  
      switch($this->message_type) {
        case 'alt':
!       case 'alt_attachments':
          $this->AltBody = $this->WrapText($this->AltBody, $this->WordWrap);
          break;
        default:
--- 1150,1158 ----
  
      switch($this->message_type) {
        case 'alt':
!       case 'alt_inline':
!       case 'alt_attach':
!       case 'alt_inline_attach':
          $this->AltBody = $this->WrapText($this->AltBody, $this->WordWrap);
          break;
        default:
***************
*** 1077,1082 ****
--- 1173,1179 ----
      $uniq_id = md5(uniqid(time()));
      $this->boundary[1] = 'b1_' . $uniq_id;
      $this->boundary[2] = 'b2_' . $uniq_id;
+     $this->boundary[3] = 'b3_' . $uniq_id;
  
      $result .= $this->HeaderLine('Date', self::RFCDate());
      if($this->Sender == '') {
***************
*** 1098,1104 ****
            $result .= $this->HeaderLine('To', 'undisclosed-recipients:;');
          }
        }
!     }
  
      $from = array();
      $from[0][0] = trim($this->From);
--- 1195,1201 ----
            $result .= $this->HeaderLine('To', 'undisclosed-recipients:;');
          }
        }
! 	}
  
      $from = array();
      $from[0][0] = trim($this->From);
***************
*** 1116,1122 ****
      }
  
      if(count($this->ReplyTo) > 0) {
!       $result .= $this->AddrAppend('Reply-to', $this->ReplyTo);
      }
  
      // mail() sets the subject itself
--- 1213,1219 ----
      }
  
      if(count($this->ReplyTo) > 0) {
!       $result .= $this->AddrAppend('Reply-To', $this->ReplyTo);
      }
  
      // mail() sets the subject itself
***************
*** 1125,1136 ****
      }
  
      if($this->MessageID != '') {
!       $result .= $this->HeaderLine('Message-ID',$this->MessageID);
      } else {
        $result .= sprintf("Message-ID: <%s@%s>%s", $uniq_id, $this->ServerHostname(), $this->LE);
      }
      $result .= $this->HeaderLine('X-Priority', $this->Priority);
!     $result .= $this->HeaderLine('X-Mailer', 'PHPMailer '.$this->Version.' (phpmailer.sourceforge.net)');
  
      if($this->ConfirmReadingTo != '') {
        $result .= $this->HeaderLine('Disposition-Notification-To', '<' . trim($this->ConfirmReadingTo) . '>');
--- 1222,1237 ----
      }
  
      if($this->MessageID != '') {
!       $result .= $this->HeaderLine('Message-ID', $this->MessageID);
      } else {
        $result .= sprintf("Message-ID: <%s@%s>%s", $uniq_id, $this->ServerHostname(), $this->LE);
      }
      $result .= $this->HeaderLine('X-Priority', $this->Priority);
!     if($this->XMailer) {
!       $result .= $this->HeaderLine('X-Mailer', $this->XMailer);
!     } else {
!       $result .= $this->HeaderLine('X-Mailer', 'PHPMailer '.$this->Version.' (http://code.google.com/a/apache-extras.org/p/phpmailer/)');
!     }
  
      if($this->ConfirmReadingTo != '') {
        $result .= $this->HeaderLine('Disposition-Notification-To', '<' . trim($this->ConfirmReadingTo) . '>');
***************
*** 1158,1175 ****
      switch($this->message_type) {
        case 'plain':
          $result .= $this->HeaderLine('Content-Transfer-Encoding', $this->Encoding);
!         $result .= sprintf("Content-Type: %s; charset=\"%s\"", $this->ContentType, $this->CharSet);
          break;
!       case 'attachments':
!       case 'alt_attachments':
!         if($this->InlineImageExists()){
!           $result .= sprintf("Content-Type: %s;%s\ttype=\"text/html\";%s\tboundary=\"%s\"%s", 'multipart/related', $this->LE, $this->LE, $this->boundary[1], $this->LE);
!         } else {
!           $result .= $this->HeaderLine('Content-Type', 'multipart/mixed;');
!           $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
!         }
          break;
        case 'alt':
          $result .= $this->HeaderLine('Content-Type', 'multipart/alternative;');
          $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
          break;
--- 1259,1279 ----
      switch($this->message_type) {
        case 'plain':
          $result .= $this->HeaderLine('Content-Transfer-Encoding', $this->Encoding);
!         $result .= $this->TextLine('Content-Type: '.$this->ContentType.'; charset="'.$this->CharSet.'"');
          break;
!       case 'inline':
!         $result .= $this->HeaderLine('Content-Type', 'multipart/related;');
!         $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
!         break;
!       case 'attach':
!       case 'inline_attach':
!       case 'alt_attach':
!       case 'alt_inline_attach':
!         $result .= $this->HeaderLine('Content-Type', 'multipart/mixed;');
!         $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
          break;
        case 'alt':
+       case 'alt_inline':
          $result .= $this->HeaderLine('Content-Type', 'multipart/alternative;');
          $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
          break;
***************
*** 1183,1188 ****
--- 1287,1302 ----
    }
  
    /**
+    * Returns the MIME message (headers and body). Only really valid post PreSend().
+    * @access public
+    * @return string
+    */
+   public function GetSentMIMEMessage() {
+     return $this->SentMIMEMessage;
+   }
+ 
+ 
+   /**
     * Assembles the message body.  Returns an empty string on failure.
     * @access public
     * @return string The assembled message body
***************
*** 1197,1202 ****
--- 1311,1343 ----
      $this->SetWordWrap();
  
      switch($this->message_type) {
+       case 'plain':
+         $body .= $this->EncodeString($this->Body, $this->Encoding);
+         break;
+       case 'inline':
+         $body .= $this->GetBoundary($this->boundary[1], '', '', '');
+         $body .= $this->EncodeString($this->Body, $this->Encoding);
+         $body .= $this->LE.$this->LE;
+         $body .= $this->AttachAll("inline", $this->boundary[1]);
+         break;
+       case 'attach':
+         $body .= $this->GetBoundary($this->boundary[1], '', '', '');
+         $body .= $this->EncodeString($this->Body, $this->Encoding);
+         $body .= $this->LE.$this->LE;
+         $body .= $this->AttachAll("attachment", $this->boundary[1]);
+         break;
+       case 'inline_attach':
+         $body .= $this->TextLine("--" . $this->boundary[1]);
+         $body .= $this->HeaderLine('Content-Type', 'multipart/related;');
+         $body .= $this->TextLine("\tboundary=\"" . $this->boundary[2] . '"');
+         $body .= $this->LE;
+         $body .= $this->GetBoundary($this->boundary[2], '', '', '');
+         $body .= $this->EncodeString($this->Body, $this->Encoding);
+         $body .= $this->LE.$this->LE;
+         $body .= $this->AttachAll("inline", $this->boundary[2]);
+         $body .= $this->LE;
+         $body .= $this->AttachAll("attachment", $this->boundary[1]);
+         break;
        case 'alt':
          $body .= $this->GetBoundary($this->boundary[1], '', 'text/plain', '');
          $body .= $this->EncodeString($this->AltBody, $this->Encoding);
